function opt_vect = foptions(opt)
% FOPTIONS Sets default parameters for optimisation routines
% For compatibility with MATLAB's foptions()
%
% Copyright (c) Dharmesh Maniyar, Ian T. Nabney (2004)
  

opt_vect      = zeros(1, 18);
opt_vect(2:3) = 1e-4;
opt_vect(4)   = 1e-6;
opt_vect(16)  = 1e-8;
opt_vect(17)  = 0.1;

if nargin,
  opt_vect0=opt_vect;
  sp=length(opt);
  opt_vect=opt_vect0*0;
  opt_vect(1:sp)=opt;
  n0=find(opt_vect==0);
  opt_vect(n0)=opt_vect0(n0);

end
