function x = gridsearch(funfcn,xlim,options,varargin)
%x = gridsearch(funfcn,xlim,options,varargin)

opts0.K0=1;
opts0.const=1.e-6;
opts0.nK=5;
opts0.logtrans=1;
opts0.relK=1.e-2;

if isempty(options),
  options=opts0;
end

ff=fieldnames(opts0);
for j=1:length(ff),
if ~isfield(options,ff{j}),
  options=setfield(options,ff{j},getfield(opts0,ff{j}));
end
end

nK=options.nK;
relK=options.relK;
tlog=options.logtrans;
const=options.const;
K0=options.K0;

Kmin = xlim(1);
Kmax = xlim(2);
if tlog,
  KMIN = log10(Kmin+K0);
  KMAX = log10(Kmax+K0);
  Kmin = KMIN;
  Kmax = KMAX;
else
  KMIN = Kmin;
  KMAX = Kmax;
end


inc = (KMAX - KMIN)/(nK-1);
Kvec = [KMIN:inc:KMAX];
Kold = Kvec;
penbest = Inf;
relnow=inf;
Kbest=xlim(1);

while relnow>relK,
  nKnow = length(Kvec);
  for j = 1:nKnow,
    if tlog,
      K = 10^(Kvec(j))-K0;
    else
      K = Kvec(j);
    end
    pen=feval(funfcn,K,varargin{:});
%     disp(['k=',num2str(K),'  pen=',num2str(pen)])
    
    if(pen < penbest)
      penbest = pen  ;   
      Kbest = K;
      Kvecbest = Kvec(j);
    end
  end
  if tlog
    diff = 10^(Kvecbest+inc)-K0 - Kbest;
    relnow=diff/(Kbest+const);
  else
    diff = inc;
    relnow=diff;
  end
  %     if (diff/(Kbest+1E-6) <= relK)
  %       break
  
  %    ## create K.vec for next pass
  Kmin = Kvecbest - floor(nK/2)/2*inc;
  Kmin = max(KMIN, Kmin);  
  Kmax = Kvecbest + floor(nK/2)/2*inc;
  Kmax = min(KMAX, Kmax)  ;
  inc = inc/2;
  Kvec = [Kmin:inc:Kmax]; 
%   ind = which.equal(log.K.vec, log.K.old);
  ind = ismember(Kvec,Kold);
  Kvec = Kvec(~logical(ind));
  Kold = [Kold, Kvec];
end

x=Kbest;