function [yf, yfse, nvr, L2, chk, stats] = sdr2it1(y2, x, TVP, nvr0, nsax, iest, irank)
% [yf, yfse, nvr, opt, chk, r2sdp] = sdr2it1(y2, x, TVP, opt, nsax, iest, irank)
%

global tstat2crit

if isempty(tstat2crit), tstat2crit=1; end

nsam=length(y2);
if nargin<3 | isempty(TVP), TVP=0; end,

if nargin<5 | isempty(nsax), nsax=nsam; end,
if nargin<6 | isempty(iest), iest=1; end,
if nargin<7 | isempty(irank), irank=1; end,

yf=zeros(nsam , 1);


% y2=y0-fp;
% sy=std(y2);
% y2=y2./sy;
% 

%   if nvr==0,
%     nvr=1.e-10;
%   end
if irank,
  xr=trank(x)-1/(2*length(y2));
else
  xr=x;
end
f1=xr(:,1)-0.5;
y=y2; %-fp;
z=[ones(nsam,1) (xr(:,1)-0.5).*(xr(:,2)-0.5) (xr(:,1)-0.5).*((xr(:,2)-0.5).^2-1/12) (xr(:,2)-0.5).*((xr(:,1)-0.5).^2-1/12) ((xr(:,1)-0.5).^2-1/12).*((xr(:,2)-0.5).^2-1/12)];
par1=(z\y);
f1=(xr(:,1)-0.5)+0.5*(par1(5)/par1(3)+par1(4)/par1(2))*((xr(:,1)-0.5).^2-1/12);
% for j=1:4, vz(j)=var(z(:,j+1).*par1(j+1)); end,
% [ss, is]=sort(vz);
% is=is([3,4]);
% if all(sort(is)==[1 2]),
%   f1=xr(:,1)-0.5;
% elseif all(sort(is)==[1 3]),
%   f1=par1(4)*((xr(:,1)-0.5).^2-1/12)+par1(2)*(xr(:,1)-0.5);
% elseif all(sort(is)==[1 4]),
%   if is(2)==4,
%     f1=(xr(:,1)-0.5).^2-1/12;
%   else
%     f1=xr(:,1)-0.5;
%   end
% elseif all(sort(is)==[2 3]),
%   if is(2)==3,
%     f1=(xr(:,1)-0.5).^2-1/12;
%   else
%     f1=xr(:,1)-0.5;
%   end
% elseif all(sort(is)==[2 4]),
%   f1=par1(5)*((xr(:,1)-0.5).^2-1/12)+par1(3)*(xr(:,1)-0.5);
% else
%   f1=(xr(:,1)-0.5).^2-1/12;
% end

[xs, I]=sort(xr);
% [NVR1,alpha,opts]=dlropt1(y(I(:,1)),xr(I(:,1),2)-0.5,TVP,'ml',-2,1,1.e-7);
%   [YC1, OUT1]=mix_cubic_spl(xr(:,1), y, xr(:,2)-0.5, 1/NVR1/nsam^4);
%   [FIT1,fit0se,F1,parse]=dlr1(y(I(:,1)),xr(I(:,1),2)-0.5,TVP,NVR1);
%   F1(I(:,1))=F1;
%   FIT1(I(:,1))=FIT1;
%   [yff, outf]=splfun(y,1,S,Q1*NVR1*nsam^4.*Q02);
% [NVR2,alpha,opts]=dlropt1(y(I(:,2)),xr(I(:,2),1)-0.5,TVP,'ml',-2,1,1.e-7);
%   [YC2, OUT2]=mix_cubic_spl(xr(:,2), y, xr(:,1)-0.5, 1/NVR2/nsam^4);
%   [FIT2,fit0se,F2,parse]=dlr1(y(I(:,2)),xr(I(:,2),1)-0.5,TVP,NVR2);
%   F2(I(:,2))=F2;
%   FIT2(I(:,2))=FIT2;
%   [yff, outf]=splfun(y,1,S,Q2*NVR2*nsam^4.*Q01);
% f1=xr(:,1)-0.5; 
f1=f1./std(f1);
for j=1:2,
  [nvr2,alpha,opts]=dlropt1(y(I(:,2)),f1(I(:,2)),TVP,'ml',-2,1,1.e-7);
  if TVP,
    nvr2=min(0.001/var(f1),nvr2);
  else
    nvr2=min(0.01/var(f1),nvr2);
  end
  [fit0,fit0se,f2,parse]=dlr1(y(I(:,2)),f1(I(:,2)),TVP,nvr2);
  f2(I(:,2))=f2;
  %     f2=f2./std(f2);
  [nvr1,alpha,opts]=dlropt1(y(I(:,1)),f2(I(:,1)),TVP,'ml',-2,1,1.e-7);
  if TVP,
    nvr1=min(0.001/var(f2),nvr1);
  else
    nvr1=min(0.01/var(f2),nvr1);
  end
  [fit0,fit0se,f1,parse]=dlr1(y(I(:,1)),f2(I(:,1)),TVP,nvr1);
  f1(I(:,1))=f1;
end
yf(I(:,1))=fit0;
% f1=f1./std(f1).*sqrt(std(yf));
% f2=f2./std(f2).*sqrt(std(yf));
yfse(I(:,1))=fit0se;

% reg=[ones(nsam,1) xr(:,1)];
f1=f1-mean(f1);
f2=f2-mean(f2);
reg=[xr(:,1)-0.5];
b=(reg'*reg)\(reg'*f1);
f01=reg*b;
f11=f1-f01;
reg=[xr(:,2)-0.5];
% reg=[ones(nsam,1) xr(:,2)];
b=(reg'*reg)\(reg'*f2);
f02=reg*b;
f12=f2-f02;

L2(1)=(mean((f01.*f02).^2));
L2(2)=(mean((f11.*f12).^2));
L2(3)=(mean((f11.*f02).^2));
L2(4)=(mean((f01.*f12).^2));

L2 = sqrt(L2./mean(L2).*(mean((f1.*f2).^2)));

nvr=[nvr1 nvr2]';


stats.r2sdp=1-cov(f1.*f2-y2)/cov(y2);
sy=std(y2);
si=cov(f1.*f2)/cov(y2);
u = (y2-f1.*f2)./sy/sqrt(1-si);
sie=(1-si)*std(y2.^2./sy^2-u.^2)/sqrt(length(u));
stats.si=si;
stats.sie=sie;
stats.tst=si/sie;
chk=1;
if stats.tst<1,
  chk=0;
end


return

