function [yt, out] = splfun(y,lam,S,Q, gcv_pen)

if nargin<5 | isempty(gcv_pen),
  gcv_pen=1;
end

n=length(y);

if nargin>=4,% | isempty(Q),
  M=(Q+n*lam*eye(n));
  invM = inv(M); 
  invSMS = inv(S'*invM*S);
%   CC= (invM-(invM*S)*invSMS*(S'*invM) );
  trCC= trace(invM)-sum(sum(((invM*S)*invSMS).*(S'*invM)' ));
%   c = CC*y;
  c = invM*y-(invM*S)*invSMS*(S'*(invM*y));
  d = invSMS*S'*(invM*y);


%   A=eye(n)-n*lam*CC;
%   df = (sum(diag(A)));
  df = n-n*lam*trCC;
%   gcv_pen=1;
%   Vlam=1/n*(y'*(eye(n)-A)'*(eye(n)-A)*y)/(1/n*sum(diag(eye(n)-A)))^2;
  A=[];

else
  Q=zeros(n,n);
  d=(S\y);
  c=zeros(n,1);
  df=length(d);
  A=[];
end
H=[S Q];
w = [d; c];
yt = H*w;


res = y-yt;
SSE = sum(res.^2);
Rsq = 1-SSE/sum((y-mean(y)).^2);

if(gcv_pen*df >= n)
  gcv = Inf;
  bic = Inf;
else
  gcv = (SSE/n)/(1-gcv_pen*df/n)^2;
  bic = n*log(SSE/n) + df*log(n);
end


out.S=S;
out.Q=Q;
out.w=w;
out.d=d;
out.c=c;
out.A=A;
out.SSE=SSE;
out.Rsq=Rsq;
out.df=df;
out.gcv=gcv;
out.bic=bic;
out.H2=c'*Q*c;


