function ssurf(x,y,z, fopt);
% function ssurf(x,y,z, fopt);
% Surface Plots of Nonuniformly Sampled Data
% fopt = 0: plot only the reconstructed surface
% fopt = 1: plot also the original Random Data

%plot3(x(:,1),x(:,3),yfit(:,1),'.')
if nargin<3, return, end,
if nargin==3 | isempty(fopt),
  fopt=0;
end
xlin = linspace(min(x),max(x),15);
ylin = linspace(min(y),max(y),15);
[X,Y] = meshgrid(xlin,ylin);
Z = griddata(x,y,z,X,Y,'cubic');

%mesh(X,Y,Z) %interpolated
surf(X,Y,Z) %interpolated
axis tight; 
if fopt,
hold on
plot3(x,y,z,'.','MarkerSize',15) %nonuniform
hold off
end
