function [Q, S] = tcubic_kdm(X,X0,ord,chk,lamk);

n = size(X,1);
nreg = size(X0,1);
np=size(X,2);

if ord==1,
  nterm=np;
else
  np2=nchoosek(np,2);
  nterm=np+np2;
  j2=nchoosek([1:np],2);
end
if length(chk)==1, 
  chk=chk*ones(nterm,1);
end
if ord==1,
  chk1=chk;
else
  chk1=chk(1:np);
  chk2=chk(np+1:end);
end
if isreal(lamk)
  if length(lamk)~=nterm ,
    if length(lamk)>1,
      error('wrong dimension for  lam')
      return
    else
      lamk=lamk(ones(nterm,1));
    end
  end
  lamk1=lamk(1:np);
  if nterm>np,
    lamk2=lamk(np+1:end);
    lamk2=[lamk2(:) lamk2(:) lamk2(:)];
  end
elseif isstruct(lamk),
  lamk1=lamk.lamk1;
  if length(lamk1)~=np ,
    if length(lamk1)>1,
      error('wrong dimension for  lamk1')
      return
    else
      lamk1=lamk1(ones(np,1));
    end
  end

  lamk2=lamk.lamk2;
  if size(lamk2,1)~=np2 ,
    if length(lamk2)>1,
      error('wrong dimension for  lamk2')
      return
    else
      lamk2=lamk2([ones(np2,1) ones(np2,1)*2 ones(np2,1)*3]);
    end
  end
  
else
  error('wrong variable type for lam')


end

% if length(lamk)~=nterm,
%   if length(lamk)>1,
%     error('wrong dimension for  lam')
%     return
%   else
%     lamk=lamk(ones(nterm,1));
%   end
% end

Q=zeros(n,nreg);
S=[ones(n,1) X(:,logical(chk1))-0.5];
for j=1:np,
  if chk1(j),
    Q = Q+cubic_dm(X0(:,j),X(:,j))./lamk1(j);
  end
end
if ord==2,
for j=1:np2,
  if chk2(j),
  Q = Q+tensor_cubic_dm(X0(:,j2(j,:)),X(:,j2(j,:)),lamk2(j,:));
  S = [S (X(:,j2(j,1))-0.5).*(X(:,j2(j,2))-0.5)];
  end
end
end